﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.ComplexEventProcessing.Extensibility;
using Microsoft.ComplexEventProcessing.Linq;
using System.Linq.Expressions;

namespace DemoConsole
{
    /// <summary>
    /// A user defined aggregate for adding up every other event in a window
    /// </summary>
    public class EveryOtherSum : CepAggregate<double, double>
    {
        public override double GenerateOutput(IEnumerable<double> payloads)
        {
            var sum = default(double);
            var include = true;
            foreach (var d in payloads)
            {
                if (include) sum += d;
                include = !include;
            }
            return sum;
        }
    }

    public static class UserDefinedAggregates
    {
        [CepUserDefinedAggregate(typeof(EveryOtherSum))]
        public static double EveryOtherSum<TPayload>(this CepWindow<TPayload> window, Expression<Func<TPayload,double>> selector)
        {
            throw CepUtility.DoNotCall();
        }
    }
}
